package associations;

import java.util.ArrayList;
import java.util.List;

/**
 * Remove mutual associations, remove one direction
 * @author hajo
 *
 */
public class RemoveMutualAssociations1 {

	public static void main(String[] args) {
		List<Customer> customers = new ArrayList<>();
		Order o = new Order();
		Customer whoToBill = null;

		// Have to search for customer of Orders
		for (Customer c : customers) {
			if (c.isOwner(o)) {
				whoToBill = c;
			}
		}
		System.out.println(whoToBill);

	}

	public static class Order {
		// No dependency on Customer
	}

	public static class Customer {
		private List<Order> orders;

		public boolean isOwner(Order order) {
			return orders.indexOf(order) >= 0;
		}
	}

}
