package construction;

import construction.Factory.IMyApp;

/**
 * Usage of centralized construction
 * 
 * @author hajo
 *
 */
public class Main {

	
	public static void main(String[] args) {
		// No 'new' here
		IMyApp i = Factory.getMyApp();

		// Now we can use i (dependencies controlled during construction)
		System.out.println(i);
	}

}
