package factory;

import factory.Factory.IMyApp;

/**
 * Usage of factory method
 * and centralized construction
 *
 * @author hajo
 *
 */
public class TestFactory {

    public static void main(String[] args) {
        // Using factory method
        Monster m = Monster.newInstance();

        // No 'new' here
        IMyApp i = Factory.getMyApp();

        // Now we can use i (dependencies controlled during construction)
        System.out.println(i);
    }

}
