	package comparator;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

/**
 * Using comparators, more flexible than comparable
 * @author hajo
 *
 */
public class Main {

    public static void main(String[] args) {
    
        List<Customer> customerList  = new ArrayList<Customer>();
        customerList.add(new Customer("123", "fff", "ccc"));
        customerList.add(new Customer("456", "aaa", "zzz"));
        customerList.add(new Customer("324", "ddd", "ggg"));
        customerList.add(new Customer("143", "ccc", "aaa"));
        // Exception
        //customerList.add(new Customer("457", "sss", null));
        
    
        Comparator<Customer> fcmp = new FirstNameComparator();     
        Collections.sort (customerList, fcmp); 
        for( Customer c : customerList){
            System.out.println( c );
        }
        System.out.println( "--------------------------" );

        Comparator<Customer> lcmp = new LastNameComparator();     
        Collections.sort (customerList, lcmp); 
        for( Customer c : customerList){
            System.out.println( c );
        }
        
    }
}
