package exception.tunneling;

/**
 * Class possible affected by exception
 * @author hajo
 *
 */
public class A {
  
  private B b;
  
  public A( B b){
    this.b = b;
  }

  // Exception will tunnel through method
  public void doIt(){
    try{
      b.doOther();
    } finally{
      // Possible cleanup
      // Exeption propagates...(not handled)
    
    }
  }
}
