package comparator;

import java.util.Comparator;

/**
 * Comparator for comparing customer last names
 */
public class LastNameComparator implements Comparator<Customer> {

    @Override
    public int compare(Customer c1, Customer c2) {
        if (c1 == c2) {
            return 0;
        }
        String lastName1 = c1.getLastName();
        String lastName2 = c2.getLastName();
        return lastName1.compareTo(lastName2);
    }
}
