package generic.basic;

/**
 * Generic inner classes
 * @author hajo
 *
 * @param <T>
 */
public class GenericInner<T> {

	// class InnerA<T> is bad T hides outer T
	private class InnerA<E> {
		private E i;
	}

	private InnerA<Integer> ia = new InnerA<Integer>();

	private T data;

	public GenericInner() {
	}

	public void setData(T data) {
		this.data = data;
	}

	public T getData() {
		return data;
	}
	
	public InnerA<Integer> getInner(){
		return ia;
	}
}
