package generic.erasure;

import java.util.Collection;
import java.util.Iterator;


/**
 * This tries to show the effect of of type erasure 
 * see all files
 */

public class Collections { 
    public static <A extends Comparable<A>>A max(Collection <A> xs) {
      Iterator <A> xi = xs.iterator();
      A w = xi.next();
      while (xi.hasNext()) {
        A x = xi.next();
        if (w.compareTo(x) < 0) w = x;
      }
      return w;
    }
  }

/*  After
public class Collections { 
    public static Comparable max(Collection xs) {
      Iterator xi = xs.iterator();
      Comparable w = (Comparable) xi.next();
      while (xi.hasNext()) {
        Comparable x = (Comparable) xi.next();
        if (w.compareTo(x) < 0) w = x;
      }
      return w;
    }
  }
*/ 