package dp.visitor;

/**
 * Any element in tree must accept a visitor
 * @author hajo
 *
 * @param <T>
 */
public interface ITree<T> {
    // R return type T type of element data in tree
    public <R> R accept( IVisitor<R, T> v);  
}
