package dp.visitor.wildcards;

public interface IVisitor<R, T> {
    // R is return type, T is type of value in tree 
    public R visit(Leaf<? extends T> leaf);
    public R visit(Node<? extends T> node); 
}
