package generic.arrays;

import java.util.ArrayList;
import java.util.List;

/**
 * Arrays and generics
 * 
 * NOTE : Arrays and generic's don't work well together, avoid
 * 
 * @author hajo
 *
 */
public class ArraysAndGenerics {

    public static void main(String[] args) {
        vildcardTypes();

    }

    private static void vildcardTypes() {
        List<?>[] lsa = new List<?>[10]; // Ok, array of unbounded wildcard type
        Object o = lsa;
        Object[] oa = (Object[]) o;
        List<Integer> li = new ArrayList<>();
        li.add(new Integer(3));
        oa[1] = li; // Correct  
        String s = (String) lsa[1].get(0); // Run time error, but cast is explicit
    }
    /*
    private static void whyNoGenericArrays() {
        // Why generic array creation is illegal - won't compile!
        List<String>[] stringLists = new List<String>[1];
        List<Integer> intList = Arrays.asList(42); // Single element list
        Object[] objects = stringLists;
        objects[0] = intList;
        String s = stringLists[0].get(0);
    }*/

}
