package reflection.plugin;

import java.util.Timer;
import java.util.TimerTask;

/**
 * The framework
 * @author hajo
 *
 */
public class BattleFramework implements IFramework{

    public void doSomeService(MissionData m) {
      System.out.println("BattleFramework: doSomeService");
    }

    // Just to show it works
    public void runIt(final IPlugin aBattle) {
       System.out.println("*** Framework starting battle " + aBattle.getClass().getSimpleName() + "***");
        new Timer().schedule(new TimerTask() {
            @Override
            public void run() {
                aBattle.upDate();
            }
        }, 2000, 1000);

        new Timer().schedule(new TimerTask() {
            @Override
            public void run() {
                aBattle.setMissionData(new MissionData());
            }
        }, 1000, 2000);
    }
}
