package hw1.out;


/**
 * Invariant: this.size == | this.header.next* | - 2
 * (i.e. list itself and header not included in length of list)
 */
public class LinkedList {
    private final Entry header = new Entry(null, null);
    private int size;
    
    public void add(Object o){
        Entry e = new Entry(o, header.next);
        header.next = e;
        size++;
    }
    /**
     * result = list containing all but the first element
     */ 
    public LinkedList tail() {
        LinkedList tl = new LinkedList();
        tl.header.next = this.header.next.next;
        tl.size = this.size - 1;
        return tl;
    }
    public int size() {
        return size;
    }
    public void dump() {
    	Entry pos = header.next;
        while( pos != null){
        	System.out.println(pos.element);
        	pos = pos.next;
        }
    }
}
