package hw5.out._5_1;
import java.awt.Color;
public class ColorPoint2 extends Point {
    private final Color color; // new field
    public ColorPoint2(int x, int y, Color color) {
        super(x, y);
        this.color = color;
    }
    public Color getColor() {
        return color;
    }
    @Override
    public boolean equals(Object o) {
        if (!(o instanceof Point)) {
            return false;
        }
        if (!(o instanceof ColorPoint2)) {
            return o.equals(this);
        }
        ColorPoint2 cp = (ColorPoint2) o;
        return super.equals(o) && cp.color == color;
    }
}
