package loopinvariant;

/**
 * 
 * Proving loops using loop invariants
 * @author hajo
 *
 */
public class LoopInvariant {

	public static void main(String[] args) {
		System.out.println(power(2, 8));
		
	}

	// Invariant i <= b && result = a ^ i
	public static int power(int a, int b) {
		int result = 1;
		int i = 0;
		// Inv must be true here
		while (i < b) {
			// If true here...
			result *= a;   // NOTE: Invariant doesn't hold here
			i++;  // Restored here
			// ..must be true here
		}
		// .. What can we deduce form inv. here?
		return result;
	}
}
