package sharedstate;

/**
 * Testing the effect of shared state
 *
 * @author hajo
 */
public class TestSharedState {

    public static void main(String[] args) {
        MyClass m1 = new MyClass();
        MyClass m2 = m1;  // Create alias

        m1.setData(99);
        System.out.println(m1.getData());

        m2.setData(-1);  // Use alias

        // Oh, oh some one changed the data
        System.out.println(m1.getData());

    }
}
