package liskov;

/**
 * A rectangle is a more general notion, so make 
 * it a superclass
 * 
 * @author hajo
 *
 */
public class Rectangle {

    private double height;
    private double width;

    // Implicit post condition
    // @post this.height == \old(this.height)
    public void setWidth(double w) {
        width = w;
    }
    // Implicit post condition
    // @post this.width == \old(this.width)
    public void setHeight(double h) {
        height = h;
    }

    public double getHeight() {
        return height;
    }

    public double getWidth() {
        return width;
    }
    
    public double area(){
    	return height * width;
    }
}
