package copyctor.uno;

/**
 * Another style for copy ctor (suggested by Uno Holmer)
 * All classes must implement ICopyable
 * 
 * No problem with sub classes
 * 
 * @author Uno Holmer
 * 
 */
public class TestCopyContructorUno {
	public static void main(String[] args) {
		A a1 = new A();
		A a2 = new B();
		A a3 = null;
		A a4 = null;

		a1.setAStrs(new String[] { "a", "b", "c" });
		// Adding a B object
		a2.setAStrs(new String[] { "x", "y", "z" });
		((B) a2).setBStrs(new String[] { "1", "2", "3" });

		a3 = a1.copyOf(); // Runtime is A
		System.out.println("a3 is: " + a3 + " runtim type is "
				+ a3.getClass().getSimpleName());

		a4 = a2.copyOf(); // Runtime is B, ok!
		System.out.println("a4 is: " + a4 + " runtim type is "
				+ a4.getClass().getSimpleName());

	}
}
