package edu.gu.cid.translator.gui;


import java.awt.Font;
import java.awt.Insets;


/**
 * This is options for the GUI nothing to do with model (pure visual)
 * 
 * @author hajo
 * 
 */
public class GUIOptions {

	private static final Font DEFAULT_FONT = new Font("Dialog", 1, 12);
	private static final Insets DEFAULT_INSETS =  new Insets(2, 2, 3, 3);
	
	private static Font font = DEFAULT_FONT;
	private static Insets insets = DEFAULT_INSETS;
		
	public static void setFont(Font font) {
		GUIOptions.font = font;
	}

	public static void setInsets(Insets insets) {
		GUIOptions.insets = insets;
	}

	public static Font getFont() {
		return font;
	}

	public static Insets getInsets() {
		return insets;
	}
	
	
}
