package swing.edt;

import javax.swing.SwingUtilities;

import swing.utilities.MainFrame;

/**
 * How to contruct the GUI (in own thread)
 * @author hajo
 *
 */
public class InitGUI {

	public static void main(String[] args) {

		// Here we have the main-thread, 
		System.out.println(Thread.currentThread());

		// Will be executed by the EDT (event dispatching thread)
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				System.out.println(Thread.currentThread());
				new MainFrame().setVisible(true);
			}
		});

		// Main -thread continues and dies here...
	}
}
