package threads.composing;

/**
 * Synchronization is not composable (calling
 * synchronized methods 
 * @author hajo
 *
 */
public class Main {
    public static void main(String[] args) {
       Counter c = new Counter();
       Thread t1 = new Thread(new CounterClient(c));
       Thread t2 = new Thread(new CounterClient(c));
     
       t1.setName("T1");
       t2.setName("T2");
       
       // Would like to have 0 or 1 forever
       t1.start();
       t2.start();
    }

}
