package freeze;


/**
 * Trying to freeze object i.e. make immutable 
 * at certain point
 * 
 * @author hajo
 * 
 */
public class Main {

	public static void main(String[] args) {
		// Intended usage
		FreezableCreator b1 = new FreezableCreator();
		b1.setO("aaa");
		// .. later ...
		b1.setS("bbb");
		FreezableCreator.Freezable f1 = b1.freeze();  // Freeze object!!!!!!
		// No setters!
		f1.getO();
		f1.getS();
		System.out.println(f1.getS());
		
			// ------------- Other examples -------------------
		// Ok
		Freezable f2 = new Freezable.Creator().setO("aaa").setS("bbb").freeze();
		// Ok
		FreezableCreator b2 = new FreezableCreator();
		FreezableCreator.Freezable f3 = b2.setO("aaa").setS("bbb").freeze();
		
		// Uninitialized, bad...
		Freezable f4 = new Freezable();
		// Uninitialized, bad ...
		FreezableCreator.Freezable f5 = new FreezableCreator.Freezable();
		
	}
}
