package nostate._static;

/**
 * Mixing instance and class variables and methods
 * @author hajo
 *
 */
public class MixInstanceAndClass {

   public static int i = 1;
   public int j = 2;
   
   
   public static void doIt(){ 
      // Ok
      i = 5;
      
      // Bad
      //i = j;
      //j = i;
      
      
      // This is a class method
      // which object should handle this?
      // doOther()         // Bad

      // this.doOther();   // Can't use this, possible no this
      
      // Ok now we know the object
      new MixInstanceAndClass().j = 5;
      new MixInstanceAndClass().doOther();
   }
   
   public void doOther(){
      // Ok
      i = 5;
      
      i = j;
      j = i;
         
      // Ok
      doIt();
   }
   
}
