
package readonly;

/**
 * Testing different approaches to read only
 * @author hajo
 */
public class TestReadOnly {

    public static void main(String[] args) {

        // ----- Interface ----------
        UsingInterface ui = new UsingInterface();

        IMutable im = ui.getM();
        // No set method!
        System.out.println(im.getData());

        // Sadly possible
        MutableClass m2 = (MutableClass) ui.getM();
        m2.setData(-999);  // Corrupt..

        // -------- Wrapper -----------
        UsingWrapper uw = new UsingWrapper();

        UsingWrapper.Wrapper w = uw.getM();
        // No set method!
        System.out.println(w.getData());

        // No casts possible
    }
}
