package polymorfism.adhoc;

/**
 * This show overload by mistake
 * @author hajo
 *
 */
public class OverloadingByMisstake {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		B b = new B();
		System.out.println("Twice as much is " + b.doubleIt(5.0));
		System.out.println("Twice as much is " + b.doubleIt(5));
	}

	// ---------- TYPES ------------------
	
	public static class A {
		// Possible to override
		public double doubleIt(double d) {
			return 10 * d;
		}
	}

	public static class B extends A {
		// OOPS! Changes the method interface:
		//Should have used @Override!
		public double doubleIt(int i) {
			return 2 * i;
		}
		// Got an overload;
	}

}
