package polymorfism.adhoc;

/**
 * Overloading is compiletime
 * @author hajo
 *
 */
public class OverloadingIsCompiletime {

	
	public static void main(String[] args) {
		IA ia = new A();
		
		ia.doit(1);  // Optimal method in runtime type not selected
	}
	
	// ------------- TYPES ---------------------
	public interface IA {
		public void doit(double i);
	}
	
	public static class A implements IA {
		public void doit(int i) {
			System.out.println("A: Do it int");
		}

        @Override
        public void doit(double i) {
            System.out.println("A: Do it double"); 
        }
	}

}
