package polymorfism.adhoc;

/**
 * Overload and type conversions
 * @author hajo
 *
 */
public class OverloadingTypeConversion2 {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		A a = new A();
		B b = new B();
		C c = new C();
		
		a.doA(1); // Implicit cast
		b.doB((int)1.9999); // Must cast, BAD!
		c.doit(1); // Select overloaded
		c.doit(1.0);// Select overloaded

	}

	public static class A {
		public void doA(double i) {
			System.out.println("A: Do it double " + i);
		}
	}
	
	public static class B {
		public void doB(int i) {
			System.out.println("B: Do it int " + i);
		}
	}

	public static class C {
		// Methods overloaded
	    public void doit(int i) {
			System.out.println("C: Do it int " + i);
		}

		public void doit(double i) {
			System.out.println("D: Do it double " + i);
		}
	}
	
	
}
