package polymorfism.universal;


/**
 * Polymorphic behavior, override
 * 
 * @author hajo
 *
 */
public class BasicOverride {

	
	public static void main(String[] args) {
		IA ia = new A();
		ia.doIt();  // Chose method from runtime type
		
		ia = new B();
		ia.doIt(); // Chose method from runtime type
	}
	

	// ----------- TYPES -------------
	
	public static interface IA {
		public void doIt();
	}
	
	public static class A implements IA {
		@Override
		public void doIt(){
			System.out.println("Do it A");
		}
	}

	public static class B implements IA {
		@Override
		public void doIt(){
			System.out.println("Do it B");
		}
		
	}
}
