package subtyping;

/**
 * Type can have many super types
 * @author hajo
 *
 */
public class MultipleSupertypes {

	public static void main(String[] args) {
		ImplAB ab = new ImplAB();

		// ab can many things
		System.out.println(ab.doA());
		System.out.println(ab.doB());

	}

	// ----------- TYPES ----------------
	
	public interface IA {
	    public abstract String doA();
	}

	public interface IB {
	    public abstract String doB();
	}
	// Have multiple super types
	public static class ImplAB implements IA, IB {
		@Override
		public String doA() {
			return "A";
		}

		@Override
		public String doB() {
			return "B";
		}

	}

	
}
