
package object;

import enums.Order;
import enums.Weekday;
import java.io.Serializable;

/**
 * Object is super type for anything *except*
 * interfaces (but conversion possible)
 * 
 * This uses many types from other packages
 * @author hajo
 */
public class TestObject {
    
    public static void main(String[] args){
        // Possible
        Object o = new Object();
        
        // Conversion from class possible
        o = new Order();
        
        // Conversion from enum
        o = Weekday.FRIDAY;
        
        // Conversion from interface (Object not super type!!!)
        Serializable s = null;
        o = s;
        
        // Conversion from array
        o = new String[]{"qqq"};
        
        o = null;
        
    }
     
}
