package overload;

/**
 * Overloading doesn't care about return type
 *
 * @author hajo
 *
 */
public class OverloadingReturntype {

    public void test() {
        A a1 = new A();
        A a2 = new B();

        double d1 = a1.doit(1);  // Conversion 1 -> 1.0
        double d2 = a2.doit(1);
        
        //int i = a2.doit(1); // Type error
    }

    // ------------- Types ---------------------
    public class A  {

        public double doit(double i) {
            System.out.println("Do it double");
            return i;
        }
    }

    public class B extends A {
        
        public int doit(int i) {
            System.out.println("Do it int");
            return i;
        }
        
        /* Inherited */
        /*public double doit(double i) {
            System.out.println("Do it double");
            return i;
        }*/
    }

}
