package associations;

import java.util.ArrayList;
import java.util.List;

/**
 * Other way to remove mutual dependency. Remove one direction
 * @author hajo
 *
 */
public class RemoveMutualAssociations2 {

	public static void main(String[] args) {
		List<Order> orders = new ArrayList<>();
		Order o = new Order(new Customer());
		orders.add(o);
		Customer whoToBill = null;
		int i = orders.indexOf(o);
		whoToBill = (i >= 0) ? orders.get(i).getOwner() : null;
		
		System.out.println(whoToBill);

	}

	public static class Order {
		private Customer owner;

		public Customer getOwner(){
			return owner;
		}
		
		public Order( Customer owner){
			this.owner = owner;
		}
	
	}

	public static class Customer {
		// No dependency on Order
	}

}
