package depencencyinversion;

/**
 * Abstraction high level (used by even higher layers)
 * @author hajo
 *
 */
public class Button {
    // Depend on low level abstraction (interface)
	private Switchable s;
	
	public Button(Switchable s){
		this.s = s;
	}
	
	public void setOn(){
		s.on();
	}
	public void setOf(){
		s.on();
	}
}
