package localinner;

/**
 * Advanced usage of anonymous inner classes 
 *
 * @author hajo
 *
 */
public class TestInner {

    public static void main(String[] args) {
        int x = 1;
        int y = 2;

        IInner c = new InnerFactory().getInner(x, y, 99); // 99 not used
        System.out.println(((InnerFactory)c).getA());

       
        x = 3;
        y = 4;

        // Long time passing.... and then...
        System.out.println("Get: " + c.getI(5));

        c.setA(999);
        System.out.println("GetA " + ((InnerFactory)c).getA());

    }
}
