package canonical.clone;

/**
 * Basic usage of clone
 *
 * @author hajo
 *
 */
public class TestClone {

    public static void main(String[] args) {
        MyClass a1 = new MyClass();
        MyClass a2;

        // Must cast! Object is return type
        a2 = (MyClass) a1.clone();

        // Check the general contract (more later, see inheritance)
        System.out.println(a1 != a2);
        System.out.println(a1.getClass() == a2.getClass());
        System.out.println(a1.equals(a2));

        // Manipulating the clone
        a2.setI(222);
        // These should differ
        System.out.println("a1 = " + a1 + " a1.i " + a1.getI());
        System.out.println("a2 = " + a2 + " a2.i " + a2.getI());

        System.out.println(a1.equals(a2));

    }

}
