package comparable;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * Using a Comparable class
 *
 * @author hajo
 *
 */
public class TestComparable {

    public static void main(String[] args) {
        List<Customer> customerList = new ArrayList<>();
        customerList.add(new Customer("123", "fff", "zzz"));
        customerList.add(new Customer("132", "fff", "ccc"));
        customerList.add(new Customer("345", "ddd", "ggg"));
        customerList.add(new Customer("241", "fff", "ggg"));
        // Duplicates ok
        customerList.add(new Customer("241", "fff", "ggg"));

        // Exception for compareTo
        // customerList.add(new Customer("241", null, "ggg"));
        // Default sorting methods works because of comparable
        Collections.sort(customerList);
        for (Customer c : customerList) {
            System.out.println(c);
        }

    }

}
