package exception.translation;

import java.io.FileNotFoundException;


/**
 * Possible repackage exception to correct abstraction level
 * @author Bruce Eckel, author of Thinking In Java
 * 
 */

public class TestExceptionTranslation {

    public static void main(String[] args) {
        try {
            try {
                throw new java.io.FileNotFoundException("Bla");
            } catch (FileNotFoundException ex) {
                ex.printStackTrace();
                throw new MeaningFullException(ex);
            }
        } catch (MeaningFullException e) {
            e.printStackTrace();
        }
        System.out.println("That's all!");
    }

}
