package hw4.out;
public class Customer {
   private final String pNumb;
   private final String firstName;
   private final String lastName;
   public Customer(String pnumb, String firstName, String lastName) {
      this.pNumb = pnumb;
      this.firstName = firstName;
      this.lastName = lastName;
   }  
   public String getPNumb() {
      return pNumb;
   }
   public String getFirstName() {
      return firstName;
   }
   public String getLastName() {
      return lastName;
   }

   @Override
   public int hashCode() {
      final int prime = 31;
      int result = 1;
      result = prime * result
            + ((firstName == null) ? 0 : firstName.hashCode());
      result = prime * result + ((lastName == null) ? 0 : lastName.hashCode());
      return result;
   }

   // Note different behavior for null
   // Equals return false
   @Override
   public boolean equals(Object obj) {
      if (this == obj)
         return true;
      if (obj == null)
         return false;
      if (getClass() != obj.getClass())
         return false;
      Customer other = (Customer) obj;
      if (firstName == null) {
         if (other.firstName != null)
            return false;
      } else if (!firstName.equals(other.firstName))
         return false;
      if (lastName == null) {
         if (other.lastName != null)
            return false;
      } else if (!lastName.equals(other.lastName))
         return false;
      return true;
   }
   
   @Override
   public String toString(){
      return pNumb + " " + firstName + " " + lastName;
   }
}
