package hw5.out._4_1;
import java.util.ArrayList;
/**
 * Simple stack.
 * @inv this.pop(this.push(s)) == s && this.stackPointer >= 0 &&
 *      this.size() == this.stackPointer
 */
class StackExtend extends ArrayList<Object> {
    private static final long serialVersionUID = 1L;
    private int stackPointer = 0;

    public void push(Object article) {
        add(stackPointer, article);
        stackPointer++;
    }
    public Object pop() {
        stackPointer--;
        return remove(stackPointer);
    }
    public void pushMany(Object[] o) {
        for (int i = 0; i < o.length; ++i)
            push(o[i]);
    }
    public int size(){
        return stackPointer;
    }
}
