package _this;

/**
 * "this" never changes type. Have to know initial object type 
 * 
 * @author hajo
 *
 */
public class ThisNeverChanges {

    public static void main(String[] args) {
        B b = new B();
        // Starting out with a type B
        b.doIt();       
    }
    
    
    //--------- TYPES --------------------
    
    public static class A {
    	
        public void doIt(){
            // Inside A but "this" is of type B (possible any sub type)!
            System.out.println( "this = " + this.getClass().getName());
        }
    }  
    
    public static class B extends A {
    }

   
}
