package covariance.clone;

public class A implements Cloneable {

	// Return type not Object!
    @Override
    public A clone() {
        try {
            Object o = super.clone();
            System.out.println("Ctor A runtime type:"
                    + o.getClass().getSimpleName());
            return (A) o;
        } catch (CloneNotSupportedException e) {
            throw new InternalError();
        }
    }
}
