package covariance.clone;

public class B extends A /* implements Cloneable */{

    // Must have this if covariant return type in A
    // If we don't class cast exception

	// Try to comment out (i.e. no clone in B)
	
    @Override
    public B clone() {
        Object o = super.clone();
        System.out.println("Ctor B runtime type :"
                + o.getClass().getSimpleName());
        return (B) o;
    }

    // Can't have this incompatible with return type A
    //@Override
    // public Object clone() { return super.clone(); }
     
}
