package equals.sametype;


public class Student extends Person {
    private String studNr;
    
    public Student(String name, String studNr) {
        super(name);
        this.studNr = studNr;
    }
    
    @Override
    public int hashCode() {
        final int PRIME = 31;
        int result = super.hashCode();
        result = PRIME * result + ((pNumb == null) ? 0 : pNumb.hashCode());
        result = PRIME * result + ((studNr == null) ? 0 : studNr.hashCode());
        return result;
    }
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!super.equals(obj))
            return false;
        if (getClass() != obj.getClass())
            return false;
        final Student other = (Student) obj;
        if (pNumb == null) {
            if (other.pNumb != null)
                return false;
        } else if (!pNumb.equals(other.pNumb))
            return false;
        if (studNr == null) {
            if (other.studNr != null)
                return false;
        } else if (!studNr.equals(other.studNr))
            return false;
        return true;
    }
   

    
    
}
