package liskov;

/**
 * Square a specialization of rectangle, make it a sub class 
 * Overrides super class methods
 *
 */
public class Square extends Rectangle { // By Java this is a subtype (extends)

    // @post from super gone! (no post is trivially weaker than some post)   
    public void setWidth(double w) {
        super.setHeight(w);
        super.setWidth(w);
    }
    
    // @post from super gone! 
    public void setHeight(double h) {
        super.setHeight(h);
        super.setWidth(h);
    }
    
}
