package copyctor.uno;

public class A implements ICopyable {

  // Run before ctor
  private String[] aStrs;

  public A() {
  }

  // Copy ctor, OK deep copy
  protected A(A a) {
    aStrs = new String[a.aStrs.length];
    for (int i = 0; i < aStrs.length; i++) {
      aStrs[i] = a.aStrs[i];
    }
  }

  // Covariant return type
  @Override
  public A copyOf() {
	  System.out.println("A copyOf, runtime type of this is : " + this.getClass().getName()); 
    // Will call protected ctor
    return new A(this);
  }
/*
  @Override
  public String toString() {
    return getClass().getName() + "@" + Integer.toHexString(hashCode()) + ":"
        + aStrs;
  }
  */
  public void setAStrs(String[] strs){
     this.aStrs = strs;
  }
  
  public String[] getString(){
      return aStrs;
  }
}
