package inherit.hiding;

/**
 *
 * @author hajo
 */
public class B extends A {

    // Static but hides instance A.i !!! Still we have inherited A.i
    public static int i = 99;
    // Not hiding A.j
    public static double j = 99.0;

    public B(){
        System.out.println(i);
        System.out.println(j);
        // Can access hidden
        System.out.println(super.i); // Here super seems to be an instance?
        System.out.println(super.j); // A warning??? Ok super is an instance...
        System.out.println(A.j); // No warning!
        super.aStaticMethod(); // .. but, here super seem to be a type?
        A.aStaticMethod();
        super.aMethod(); // Here super seems to be an instance?
    }
    
    /* Can't hide instance method !!!
     public static void aMethod(){
     System.out.println("B method");
     }*/
    //Hides A's method
    public static void aStaticMethod() {
        System.out.println("aStaticMethod in B");
    }
}
