package edu.gu.cid.trie;

import java.util.List;

public interface IConnectableTrie {
	
	public abstract TrieNode insert(String key);
	
	public abstract List<String> getKeys(String prefix);
	
	public abstract List<String> getValues(String key);
	
	public abstract boolean contains(String key); 
}