package edu.gu.hajo.mbclient.core;

import edu.gu.hajo.mbclient.core.state.IState;
import edu.gu.hajo.mbclient.event.EventBus;
import edu.gu.hajo.mbcommon.IClient;
import edu.gu.hajo.mbcommon.IPeer;

/**
 * 
 * Handling the client as a singleton (in different shapes)
 * @author hajo
 * 
 *                 
 */
public class ClientFactory {

    private static final Client INSTANCE;

    static {
        EventBus eb = EventBus.INSTANCE;
        IState ctx = null; // <------------------------------- HERE
        INSTANCE = new Client(eb, ctx);
    }
    
    private ClientFactory(){
    }
/*  TODO
    public static IClient getClient() {
        return INSTANCE;
    }
*/
    public static ILocalClient getLocalClient() {
        return INSTANCE;
    }
/* TODO
    public static IPeer getPeer() {
        return INSTANCE;
    }
*/
}
