package edu.gu.hajo.mbserver.core;

import java.rmi.RemoteException;
import java.util.logging.Logger;

import edu.gu.hajo.mbcommon.IServer;

/**
 * The server
 * 
 * @author hajo
 * 
 */
public class Server implements IServer {

    private final int TIMER_DELAY = 3000; // For reclaiming clients
    private final Logger log = Logger.getAnonymousLogger(); // Use this for logging

   
    private final int registryPort;
    private final int serverPort;
  

    public Server(int registryPort, int serverPort) {
        this.registryPort = registryPort;
        this.serverPort = serverPort;
      

    }
    
    @Override
    public String ping() throws RemoteException {
        return "Alive at serverPort " + serverPort + ". Registry port is "
                + registryPort;
    }
}
