package threads.composing;

public class CounterClient implements Runnable {

   Counter c;

   public CounterClient(Counter c) {
      this.c = c;
   }

   public void run() {
      while (true) {
         // This will help...(lock object)
         // synchronized (c) {
            c.increment();
            System.out.println(Thread.currentThread().getName() + ":"
                  + c.value());
            c.decrement();
            System.out.println(Thread.currentThread().getName() + ":"
                  + c.value());
         //}
      }
   }
}
