package threads.basic;

/**
 * This  class manages it own thread
 * @author hajo
 *
 */
public class Z implements Runnable {

    // Thread for running myself!
    private Thread myThread = new Thread(this);
    private boolean done = false;

    @Override
    public void run() {
        while (!done) {
            System.out.println("I'm Z run by " + myThread.getName());
            try {
                // Let actual thread sleep 2 sec
                Thread.sleep(4000);
            } catch (InterruptedException e) {

                e.printStackTrace();
            }
        }
        System.out.println("Z says.... farewell cruel word grahhhhh... " );
    }

    public void start() {
        myThread.setName("Z thread");
        myThread.start();
    }

    // This is the way to stop a thread
    public void stop() {
        done = true;
    }
}
