package threads.composing;

public class Counter {

    private int c = 0;

    // This won't help, composition of
    // thread safe methods aren't thread safe
    public synchronized void increment() {
        c++;
    }
    // As above
    public synchronized void decrement() {
        c--;
    }

    public int value() {
        return c;
    }  
}
