package threads.racecondition;

/**
 * To be run in a thread
 * @author hajo
 *
 */
public class CounterClient implements Runnable {

   Counter c;

   public CounterClient(Counter c) {
      this.c = c;
   }

   // After this c.value() should be 0 !!
   public void run() {
      while (true) {
         c.increment();
         System.out.println(Thread.currentThread().getName() + ":" + c.value());
         c.decrement();
         System.out.println(Thread.currentThread().getName() + ":" + c.value());
      }
   }
}
