package immutable;

/**
 * A basic immutable class. No references
 * @author hajo
 *
 */
public final class ImmutableClass1 { // final, can't subclass. More later

    // final = can't change
    private final int data;
  
    public ImmutableClass1(int data){
      this.data = data;
    }
    // No set, just a get!
    public int getData(){
      return data;
    } 
}
