package nostate;

/**
 * A stateless class.
 * 
 *
 * @author hajo
 *
 */
public class StatelessClass {
	
	// Can't create objects (class Math implements the same)
	private StatelessClass(){
	}
	
	public static int square(int i){
		return i * i;
	}
	
	public static int cube(int i){
		return i * i * i;
	}	
	
	// ... etc.
}
