package immutable;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Immutable collection (a copy created)
 * @author hajo
 *
 */
public class ImmutableCollection {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		List<String> strs = new ArrayList<>();
		
		strs.add("aaa");
		strs.add("bbb");
		strs.add("ccc");
		
		List<String> immutable = Collections.unmodifiableList(strs);
		
		// Exception
		//immutable.add("ddd");
		//immutable.remove(0);
		System.out.println(immutable.get(0));
                
                List<Integer> is = Arrays.asList(1,2,3,4,5);
                // is.add(6);  // Exception
	    
	}

	
}
