/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package readonly;

/**
 *
 * @author hajo
 */
public class UsingWrapper {

    MutableClass m = new MutableClass();

    // Send out read only reference type
    // Not exposing the mutable class
    public Wrapper getM() {
        return new Wrapper(m);
    }

    // Inner wrapper 
    public final class Wrapper {

        private final MutableClass m;

        public Wrapper(MutableClass m) {
            this.m = m;
        }

        public int getData() {
            return m.getData();
        }
    }
}
