package typeconversions;

/**
 * This is mostly non-reference conversion
 * @author hajo
 *
 */
public class NoneReferenceConversions {

	// Normally no loss of information)
	public void wideningPrimitive() {
		int i = 1000;
		long j = i;
		float f = j;
		
		System.out.println(j - i);  // No loss of information
		System.out.println(f - i);  // No loss of information
		
		// but....
		int big = 1234567890;
        float approx = big;
        System.out.println(approx); // Oh, oh...too few significant digits
        
        // Ok.
        double approxD = big;
        System.out.println(approxD);
        
	}
	
	// Normally loose information
	public void narrowingPrimitive() {
		float f = 1.23456f;   // ending f else double
		// Error
		//int i = f;	
		System.out.println("Conversion not allowed for " + f);
	}
	
	public void boxingConversion(){
		Integer i = new Integer(1);  // Ok
		int j = i;
		Integer k = j;
		System.out.println(k);
	}
	
	public void primitiveArrayConversion(){
	    int[] iarr = new int[5];
        double[] darr = new double[5];
        // No
        //darr = iarr;  //NOTE: double :> int , JLS 4.10.1
        //iarr = darr;
        
	}
}
